
-- You only have to do this once per instance. Ever.

:CONNECT localhost\SQL1

-- endpoint certs must be in master
USE MASTER
GO

IF NOT EXISTS
  (SELECT * FROM sys.symmetric_keys WHERE name = '##MS_DatabaseMasterKey##')
CREATE MASTER KEY ENCRYPTION BY PASSWORD = 'StrongPW1'
GO

-- Define the cert for my endpoint
-- Owned by DBO in MASTER

DECLARE @cmdstr NVARCHAR(255);
SET @cmdstr = 
'CREATE CERTIFICATE BrokerEndpointCert_SQL1
WITH SUBJECT = ''BrokerEndpointCert_SQL1'',
START_DATE = ' + '''' 
+ convert(NVARCHAR(10), dateadd(day, -3, getdate()), 101)
+ ''''
PRINT @cmdstr
EXECUTE sp_executesql @cmdstr
GO

--
-- Back the certificate up to a file
-- This only backs up the public key, not the private key
--
BACKUP CERTIFICATE BrokerEndpointCert_SQL1
TO FILE = 'c:\certs\BrokerEndpointCert_SQL1_pub.cer'
GO

-- create endpoint, authentication by cert
-- unless you have a good reason, encryption should be disabled

CREATE ENDPOINT BrokerEndpoint_SQL1
STATE = STARTED
AS TCP
(
  LISTENER_PORT = 4567
)
FOR SERVICE_BROKER
(
  AUTHENTICATION = CERTIFICATE BrokerEndpointCert_SQL1,
  ENCRYPTION = REQUIRED
);
go

--check that the endpoint has been created
select * from sys.service_broker_endpoints;
go