
-- You have to do this once per instance
-- That wants to connect to you
-- Whether you're the initiator or target

-- This allows instance SQL1 to connect

:CONNECT localhost

USE MASTER
GO

--create a login and a user which you eventually will assign a public
--key from the cert in the remote master db to

IF EXISTS(
  SELECT * FROM sys.certificates 
   WHERE name = N'BrokerEPCert_SQL1'
)
DROP CERTIFICATE BrokerEPCert_SQL1
GO

IF  EXISTS (SELECT * FROM sys.database_principals WHERE name = N'BrokerEPUser_SQL1')
DROP USER [BrokerEPUser_SQL1]
GO

IF  EXISTS (SELECT * FROM sys.server_principals WHERE name = N'BrokerEPLogin_SQL1')
DROP LOGIN [BrokerEPLogin_SQL1]
GO

create login BrokerEPLogin_SQL1
	with password = 'StrongPW1';
go

create user BrokerEPUser_SQL1
	from login BrokerEPLogin_SQL1;
go

--grant connect to the endpoint to the login
grant connect on endpoint::BrokerEndpoint to BrokerEPLogin_SQL1
go

-- public key only
create certificate BrokerEPCert_SQL1
authorization BrokerEPUser_SQL1
from file = 'c:\certs\BrokerEndpointCert_SQL1_pub.cer';
go