
-- You have to do this once per instance
-- That wants to connect to you
-- Whether you're the initiator or target

-- This allows instance localhost to connect

:CONNECT localhost\SQL1

USE MASTER
GO

IF EXISTS(
  SELECT * FROM sys.certificates 
   WHERE name = N'BrokerEPCert'
)
DROP CERTIFICATE BrokerEPCert
GO

IF  EXISTS (SELECT * FROM sys.database_principals 
	WHERE name = N'BrokerEPUser')
DROP USER [BrokerEPUser]
GO

IF  EXISTS (SELECT * FROM sys.server_principals 
	WHERE name = N'BrokerEPLogin')
DROP LOGIN [BrokerEPLogin]
GO


--create a login and a user which you eventually will assign a public
--key from the cert in the remote master db to
create login BrokerEPLogin
	with password = 'StrongPW1';
go

create user BrokerEPUser
	from login BrokerEPLogin;
go

--grant connect to the endpoint to the login
grant connect on endpoint::BrokerEndpoint_SQL1 to BrokerEPLogin
go

create certificate BrokerEPCert
authorization BrokerEPUser
from file = 'c:\certs\BrokerEndpointCert_pub.cer';
go