drop table t1
drop table t2
go
create table t1 (
 col1 int,
 col2 int
)
go
create table t2 (
 col1 int,
 col2 int
)
go

-- test
select t1.col2, t2.col2 from t1 join t2 on t1.col1 = t2.col1 where t1.col1 = 50000
go

select text, plan_handle, memory_object_address 
from sys.dm_exec_cached_plans cp
cross apply sys.dm_exec_sql_Text(cp.plan_handle)
go

select * from dbo.CompPlanDetails(
  0x050A00C0,
  0x06000B001FDCE236B8010A05000000000000000000000000
)
go

drop procedure p1
go 
create procedure p1
as 
begin
      select col1 from t1
      select col2 from t1 where col1 = 50000
end
go
 
exec p1
go


select text, plan_handle, memory_object_address 
from sys.dm_exec_cached_plans cp
cross apply sys.dm_exec_sql_Text(cp.plan_handle)
go

select * from dbo.CompPlanDetails(
  0x048DC0C0,
  0x05000B000DD07C4FB8C18D04000000000000000000000000
)
go

exec PlanBreakdown 0x048DC0C0
go
 
-- See the summaries for each plan.
select * from PlanSummary
 
-- See the details for each plan.
select * from PlanDetails
go

-- this should use two connections 
-- and should execute at the same time as query below
-- Connection 1:
 
alter table t1 add col3 int
go

--  
-- Connection 2:
 
create procedure p1
as 
begin
      ---long running queries
      select * from t1 where col1 = 5;
      select * from t2 where col1 = 10;
      ---long running queries
end
go
 
exec p1
go
