
create proc sales_report @country_id int
as begin
      select * from sales where country_id = @country_id
end
go
 
-- Approach 1: Create the procedure by adding WITH RECOMPILE to stored procedure 
-- definition as below.
 
create proc sales_report @country_id int with recompile 
as begin
      select * from sales where country_id = @country_id
end
go

-- Approach 2: Add the WITH (RECOMPILE) hint to the query inside the stored procedure
create proc sales_report @country_id int
as begin
select * from sales where country_id = @country_id option (recompile)
end
go

-- Approach 3:
exec sales_report @country_id = 2 with recompile
go


