
---this is an example for how to use sys.dm_exec_plan_attributes
if exists(select col1 from t1 where col2 > 5) declare @x int;
go
 
-- Use the query below to view the cached compiled plans: 
 
select text, plan_handle, cacheobjtype, objtype 
from sys.dm_exec_cached_plans cp cross apply sys.dm_exec_sql_text(plan_handle)
where cacheobjtype = 'Compiled Plan' 
go

-- To see why there are two different plans
select st.text, cp.plan_handle, cp.cacheobjtype, cp.objtype, pa.attribute, pa.value, pa.is_cache_key
from sys.dm_exec_cached_plans cp cross apply sys.dm_exec_sql_text(plan_handle) st
outer apply sys.dm_exec_plan_attributes(cp.plan_handle) pa
where cp.cacheobjtype = 'Compiled Plan' and cp.objtype = 'Adhoc' 
and st.text not like '%select st.text%' and pa.is_cache_key = 1 
order by pa.attribute;
go

-- two triggers, same SQLCLR method
create trigger dml_clr_trigger1 on t1 after update
as external name trigger_assembly.test_class.test_method
go
 
create trigger dml_clr_trigger2 on t2 after update
as external name trigger_assembly.test_class.test_method
go

/* 
In test_method() we execute the following query:
 
using SqlConnection connection = new SqlConnection ("context connection = true");
connection.Open();
SqlCommand command = connection.CreateCommand();     
command.CommandText = "if exists(select * from inserted) declare @x int";
command.ExecuteNonQuery();
*/